import { IComponentDefinition, IBuildOptions, IComponentOptions } from "./ComponentComposer";
import { IClientManifest, IClientManifestProvider, IManifest } from "./ManifestRegistry";
export declare class ComponentRegistration {
    componentOptions: IComponentOptions;
    manifestPath: string;
    manifest: IManifest;
    buildOptions: IBuildOptions;
    definition: IComponentDefinition;
    constructor(componentOptions: IComponentOptions, manifestPath: string, manifest: IManifest);
}
export interface IComponenentManifest extends IClientManifest {
    /** The name for this component, this should be a none conflicting name
        e.g. use project as prefix myuniqueprojectname-componentName.
        i.e. <myuniqueprojectname-componentName></myuniqueprojectname-componentName> */
    elementName: string;
    definition: IComponentDefinition;
}
export declare class ComponentRegistry implements IClientManifestProvider {
    private static ComponentRegistrations;
    private static ComponentElements;
    static registerComponent: (manifest: IManifest, componentOptions: IComponentOptions) => void;
    static addComponentDefinition: (manifest: IManifest, definition: IComponentDefinition) => void;
    static addComponentBuildOptions: (manifest: IManifest, buildOptions: IBuildOptions) => void;
    static getRegistrations: () => ComponentRegistration[];
    getClientManifests: (currentExtensionId: string) => IComponenentManifest[];
    clearState: () => void;
    private static ensureCorrectManifest;
}
